---
# BBOSS Copyright (C) 2018-2021, Laurent Marchelli
# SPDX-License-Identifier: GPL-3.0-or-later

- name: Tools - Create fake Certificate Authority for tests
  hosts: localhost
  tasks:
    - name: Tools - Create Certificate Authority key (4096 bits, RSA)
      community.crypto.openssl_privatekey:
        path: files/fake_ca.key
      register: ca_key

    - name: Tools - Create Certificate Authority request
      community.crypto.openssl_csr:
        path: files/fake_ca.csr
        privatekey_path: "{{ ca_key.filename }}"
        country_name: FR
        locality_name: Paris
        organization_name: Bboss.org
        email_address: admin@bboss.org
        common_name: FAKE CA - DO NOT USE FOR PRODUCTION
        # constraints and usage required by CA
        basic_constraints_critical: true
        basic_constraints:
          - CA:TRUE
          - pathlen:0
        key_usage:
          - digitalSignature
          - cRLSign
          - keyCertSign
      register: ca_csr

    - name: Tools - Sign Certificate Authority request
      community.crypto.x509_certificate:
        path: files/fake_ca.crt
        csr_path: "{{ ca_csr.filename }}"
        privatekey_path: "{{ ca_key.filename }}"
        provider: selfsigned
      register: ca_crt

    - name: "Tools - Cleanup certificate Autority request"
      ansible.builtin.file:
        path: files/fake_ca.csr
        state: absent
